import React, { useState, useEffect, useRef } from "react";
import socketIOClient from "socket.io-client";

//const host = "http://admin.elevate-mobility.com:27271";
const host = "http://tatu:fYg5FRbQ@connect-ink.com:27271";
function App() {
  const [mess, setMess] = useState([]);
  const [message, setMessage] = useState('');
  const [id, setId] = useState();

  const socketRef = useRef();
  const messagesEnd = useRef();

  useEffect(() => {
    socketRef.current = socketIOClient.connect(host)
    socketRef.current.on('getId', data_send => {
      setId(data_send)
    })
    //socketRef.current.on('receiveStreamOrder', dataGot => {
    //  setMess(oldMsgs => [...oldMsgs, dataGot.data_send ])
    //})
    socketRef.current.on('sendDataServer', dataGot => {
      setMess(oldMsgs => [...oldMsgs, dataGot.data_send ])
    })
    return () => {
      socketRef.current.disconnect();
    };
  }, []);
  const sendMessage = () => {
    /*var msg_date = new Date().toLocaleString("en-GB", {timeZone: "Asia/Jakarta"});
    var msg_date_arr  = msg_date.split(",");
        var msg_datetime =  msg_date_arr[0] + msg_date_arr[1];*/
    if (message !== null) {
      const msg = {
        content: message,
        id: "a0000002",
        name: "Đạt Phạm",
        artist_id: "ART00000002",
        artist_name: "Dat",
        chat_user: 'artist',
        event_type: 'data',
        event_id: 'data.event_id'
      }
      socketRef.current.emit('sendDataClient', msg)
      setMessage('')
    }
  }

  const renderMess = mess.map((m, index) =>
    <div
      key={index}
      className={`${m.id === id ? 'your-message' : 'other-people'} chat-item`}
    >
      {"Content: " + m.content + " response: " + m.chat_user }
      {/*"Error: " + m.error*/}
    </div>
  )


  const onEnterPress = (e) => {
    if (e.keyCode === 13 && e.shiftKey === false) {
      sendMessage()
    }
  }

  const handleChange = (e) => {
    setMessage(e.target.value)
  }

  return (
      <div className="box-chat">
        <div className="box-chat_message">
          {renderMess}

          <div style={{ float: "left", clear: "both" }}
            ref={messagesEnd}>
          </div>
        </div>

        <div className="send-box">
          <textarea
            value={message}
            onKeyDown={onEnterPress}
            onChange={handleChange}
            placeholder="Nhập tin nhắn ..."
          />
          <button onClick={sendMessage}>
            Send
          </button>
        </div>
      </div>
  );
}

export default App;